import * as AST from '../ast';
import Env, { EnvError } from '../env';
import Token from '../token';

export class Identifier {
  public name: Token;

  public constructor(name: Token) {
    this.name = name;
  }

  public compile(env: Env, opts: AST.Opts): string | EnvError {
    const value = env.get(this.name);
    if (value instanceof EnvError) return value;
    return value.compile(env, opts);
  }
}
